﻿XIncludeFile "ADSL_Form.pbf"

InitNetwork()

Procedure.s SendModemData(Connect, Command.s) ; Процедура, передающая команду модему и получающая от него ответ
  Result_SendModemData.s=""
  Count=0
  Command=Command+Chr(13)+Chr(10)
  SendNetworkString(Connect, Command, #PB_Ascii) ; Передача команды
  
  Repeat                                          ; В цикле ожидается ответ
    Delay(20)
    If NetworkClientEvent(Connect)=#PB_NetworkEvent_Data ; От модема получены данные
      *mem=AllocateMemory(10000)                 ; Память под данные
      If *mem
        ReceiveNetworkData(Connect,*mem,10000) ; Считывание данных
        In.s=PeekS(*mem, -1, #PB_Ascii)
        FreeMemory(*mem)
        Result_SendModemData=Result_SendModemData+In
      EndIf
    EndIf
    Count+1
  Until Count>=80
  ProcedureReturn Result_SendModemData
EndProcedure

Procedure ModemConnect(IP.s, Login.s, Password.s, *Error.Long=0)
  Protected Connect, Err=0, Count=0, ConnectState=0
  
; Соединение с модемом
; Address - IP адрес
; Login - Логин модема
; Password - Пароль модема
; *Error - номер ошибки. 
;   0 - Ошибок нет
;   1 - пробема при выделении памяти
;   2 - нет ответа от модема в течение 1 секунды
;   3 - Не удалось подключиться к модему
;   4 - Неправильный логин или пароль


 Login=Login+Chr(13)+Chr(10)
 Password=Password+Chr(13)+Chr(10)
 
 ;Debug Address
 Connect=OpenNetworkConnection(IP, 23)

 Delay(100)
 If Connect
  Count=0
  Repeat
 
    If NetworkClientEvent(Connect)=#PB_NetworkEvent_Data
      
     If ConnectState<2
        *mem=AllocateMemory(10000)
        If *mem
          ReceiveNetworkData(Connect,*mem,10000)
          In.s=PeekS(*mem, -1, #PB_Ascii)
          FreeMemory(*mem)
        Else
          Err=1
          Break
        EndIf
        
        If FindString(LCase(In),"login",1) 
        
         If ConnectState=0
           SendNetworkString(Connect, Login, #PB_Ascii)
           Delay(200)
           ConnectState=1
         Else
           Err=4
           Break
         EndIf
         
        ElseIf FindString(LCase(In),"password",1)
          If ConnectState=1
            SendNetworkString(Connect, Password, #PB_Ascii)
            Delay(200)
            Test.s="ping"+Chr(13)+Chr(10)
            SendNetworkString(Connect, Test, #PB_Ascii)
            ConnectState=2
          Else
           Err=4
           Break
          EndIf
         
        EndIf
      Else
        ConnectState=3
        Count=0
         *mem=AllocateMemory(10000)
        If *mem
          ReceiveNetworkData(Connect,*mem,10000)
          In.s=PeekS(*mem, -1, #PB_Ascii)
          FreeMemory(*mem)
          
          
          If FindString(LCase(In),"login",1) Or FindString(LCase(In),"password",1)
             Err=4
             Break
          EndIf
          
        EndIf
      EndIf
    Else
     
     Count+1
     If Count>100 And ConnectState=3
       Break
     ElseIf Count>200
       Err=2
       Break
     EndIf
    EndIf
    
    Delay(20)
  Until Count>200
  
  If Err>0 And Connect
    CloseNetworkConnection(Connect)
    Connect=0
  EndIf
 
 Else
    Err=3
 EndIf
 
 If *Error
   *Error\l=Err
 EndIf

ProcedureReturn Connect
EndProcedure


EnableExplicit


Procedure TrackBar_Param_Event()
  Protected Param
  
  Param = GetGadgetState(#TrackBar_Param)
  
  If Param>100
    Param*7-600
  EndIf
  
  SetGadgetText(#Text_Param, "Параметр = "+Param)
  
  ProcedureReturn Param
EndProcedure


Procedure ADSL_ModLine()
  Protected IP.s, Login.s, Password.s
  Protected Err.l, Connect, snr
  
  IP = GetGadgetText(#IP_Modem)
  Login = GetGadgetText(#String_Login)
  Password = GetGadgetText(#String_Pass)
  snr=TrackBar_Param_Event()
  
  If Login="" Or Password=""
    MessageRequester("", "Заполните поля!", #MB_OK|#MB_ICONWARNING)
    ProcedureReturn
  EndIf
  
  Connect = ModemConnect(IP.s, Login, Password, @Err)
  
  If Connect
    
    Delay(400)
    SendModemData(Connect, "adsl start --snr "+snr)
    
    Delay(1000)
;     SendModemData(Connect, "save")
;     
;     Delay(4000)
;     
;     SendModemData(Connect, "reboot")
;     
;     Delay(10000)
    
    CloseNetworkConnection(Connect)
    MessageRequester("", "Информция в модеме обновлена."+Chr(10)+
                         "Сейчас произойдет переазпуск ADSL"+Chr(10)+
                         "и около минуты не будет интернета.", #MB_OK|#MB_ICONINFORMATION)
  Else
    
    If Err=1
      MessageRequester("", "Ошибка программы."+Chr(10)+"Попробуйте её перезапустить.",
                       #MB_OK|#MB_ICONWARNING)
    ElseIf Err=2
      MessageRequester("", "Модем не ответил на запрос в течение секунды."+Chr(10)+
                           "Попробуйте повторить попытку.", #MB_OK|#MB_ICONWARNING)
    ElseIf Err=3
      MessageRequester("", "Не удалось установить связь с модемом!", #MB_OK|#MB_ICONERROR)
    ElseIf Err=4
      MessageRequester("", "Неправильный логин или пароль!", #MB_OK|#MB_ICONWARNING)
    EndIf
  
  EndIf
  
EndProcedure

DisableExplicit


OpenWindow_0()
SetGadgetState(#IP_Modem, MakeIPAddress(192, 168, 1, 1))
SetGadgetState(#TrackBar_Param, 100)
TrackBar_Param_Event()
BindGadgetEvent(#TrackBar_Param, @TrackBar_Param_Event())
BindGadgetEvent(#Button_Send, @ADSL_ModLine())

Repeat
  Event = WaitWindowEvent()  
Until Event = #PB_Event_CloseWindow
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 169
; FirstLine = 143
; Folding = -
; EnableXP